# std::reverse_iterator< _Iterator > Class Template Reference

`#include <stl_iterator.h>`

Inheritance diagram for std::reverse_iterator:

[legend]
Collaboration diagram for std::reverse_iterator< _Iterator >:

[legend]
List of all members.

## Public Methods

| reverse_iterator ()
| reverse_iterator (iterator_type __x)
| reverse_iterator (const reverse_iterator &__x)
template<typename _Iter> | reverse_iterator (const reverse_iterator< _Iter > &__x)
iterator_type | base () const
reference | operator * () const
pointer | operator-> () const
reverse_iterator & | operator++ ()
reverse_iterator | operator++ (int)
reverse_iterator & | operator-- ()
reverse_iterator | operator-- (int)
reverse_iterator | operator+ (difference_type __n) const
reverse_iterator & | operator+= (difference_type __n)
reverse_iterator | operator- (difference_type __n) const
reverse_iterator & | operator-= (difference_type __n)
reference | operator[] (difference_type __n) const

## Detailed Description

### template<typename _Iterator>
class std::reverse_iterator< _Iterator >

"Bidirectional and random access iterators have corresponding reverse iterator adaptors that iterate through the data structure in the opposite direction. They have the same signatures as the corresponding iterators. The fundamental relation between a reverse iterator and its corresponding iterator `i` is established by the identity:

          &*(reverse_iterator(i)) == &*(i - 1)

This mapping is dictated by the fact that while there is always a pointer past the end of an array, there might not be a valid pointer before the beginning of an array." [24.4.1]/1,2

Reverse iterators can be tricky and surprising at first. Their semantics make sense, however, and the trickiness is a side effect of the requirement that the iterators must be safe.

Definition at line 90 of file stl_iterator.h.

## Constructor & Destructor Documentation

template<typename _Iterator>
std::reverse_iterator< _Iterator >::reverse_iterator | ( |  | ) | `[inline]`

| The default constructor gives an undefined state to this iterator. Definition at line 111 of file stl_iterator.h. Referenced by std::reverse_iterator< _Iterator >::operator--().

template<typename _Iterator>
std::reverse_iterator< _Iterator >::reverse_iterator | ( | iterator_type | __x | ) | `[inline, explicit]`

| This iterator will move in the opposite direction that `x` does. Definition at line 117 of file stl_iterator.h.

template<typename _Iterator>
std::reverse_iterator< _Iterator >::reverse_iterator | ( | const reverse_iterator< _Iterator > & | __x | ) | `[inline]`

| The copy constructor is normal. Definition at line 122 of file stl_iterator.h.

template<typename _Iterator>
template<typename _Iter>
std::reverse_iterator< _Iterator >::reverse_iterator | ( | const reverse_iterator< _Iter > & | __x | ) | `[inline]`

| A reverse_iterator across other types can be copied in the normal fashion. Definition at line 130 of file stl_iterator.h. References std::reverse_iterator< _Iterator >::base().

## Member Function Documentation

template<typename _Iterator>
iterator_type std::reverse_iterator< _Iterator >::base | ( |  | ) | const`[inline]`

Returns:
  `current`, the iterator used for underlying work.

Definition at line 137 of file stl_iterator.h.

Referenced by std::operator+(), std::operator-(), std::operator==(), and std::reverse_iterator< _Iterator >::reverse_iterator().

template<typename _Iterator>
reference std::reverse_iterator< _Iterator >::operator * | ( |  | ) | const`[inline]`

Returns:
  TODO

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 146 of file stl_iterator.h.

template<typename _Iterator>
reverse_iterator std::reverse_iterator< _Iterator >::operator+ | ( | difference_type | __n | ) | const`[inline]`

Returns:
  TODO

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 221 of file stl_iterator.h.

template<typename _Iterator>
reverse_iterator std::reverse_iterator< _Iterator >::operator++ | ( | int |  | ) | `[inline]`

Returns:
  TODO

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 181 of file stl_iterator.h.

template<typename _Iterator>
reverse_iterator& std::reverse_iterator< _Iterator >::operator++ | ( |  | ) | `[inline]`

Returns:
  TODO

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 168 of file stl_iterator.h.

template<typename _Iterator>
reverse_iterator& std::reverse_iterator< _Iterator >::operator+= | ( | difference_type | __n | ) | `[inline]`

Returns:
  TODO

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 231 of file stl_iterator.h.

template<typename _Iterator>
reverse_iterator std::reverse_iterator< _Iterator >::operator- | ( | difference_type | __n | ) | const`[inline]`

Returns:
  TODO

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 244 of file stl_iterator.h.

template<typename _Iterator>
reverse_iterator std::reverse_iterator< _Iterator >::operator-- | ( | int |  | ) | `[inline]`

Returns:
  TODO

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 207 of file stl_iterator.h.

References std::reverse_iterator< _Iterator >::reverse_iterator().

template<typename _Iterator>
reverse_iterator& std::reverse_iterator< _Iterator >::operator-- | ( |  | ) | `[inline]`

Returns:
  TODO

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 195 of file stl_iterator.h.

template<typename _Iterator>
reverse_iterator& std::reverse_iterator< _Iterator >::operator-= | ( | difference_type | __n | ) | `[inline]`

Returns:
  TODO

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 254 of file stl_iterator.h.

template<typename _Iterator>
pointer std::reverse_iterator< _Iterator >::operator-> | ( |  | ) | const`[inline]`

Returns:
  TODO

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 159 of file stl_iterator.h.

template<typename _Iterator>
reference std::reverse_iterator< _Iterator >::operator[] | ( | difference_type | __n | ) | const`[inline]`

Returns:
  TODO

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 267 of file stl_iterator.h.

The documentation for this class was generated from the following file:

- stl_iterator.h